using System;
using System.ComponentModel;
using System.Collections;
using System.Diagnostics;

/**
 * NOTE: values are hardcoded till now cause this panel cannot be resized and 
 * font size in SourceTextBox cannot be changed!
 * 
 * TO DO: sourcebox scrolled -> this must also be 'scrolled'
 **/

namespace BrainfuckStudio
{
	/// <summary>
	/// Zusammenfassung fr BreakpointPanel.
	/// </summary>
	public class BreakpointPanel : System.Windows.Forms.Panel
	{
		private static int lineHeight = 16;

		// hold all breakpoints
		private static System.Collections.ArrayList breakpoints;
		

		public BreakpointPanel()
		{
			breakpoints = new ArrayList(10);

			this.MouseDown += new System.Windows.Forms.MouseEventHandler(BreakpointPanel_MouseDown);
		}

		private void BreakpointPanel_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int lineNum = (int)(e.Y / lineHeight);

			if (e.Button == System.Windows.Forms.MouseButtons.Left)
			{
				// set the breakpoint
				if (!breakpoints.Contains(lineNum))
					breakpoints.Add(lineNum);
			}
			else if (e.Button == System.Windows.Forms.MouseButtons.Right)
			{
				// remove the breakpoint
				if (breakpoints.Contains(lineNum))
					breakpoints.Remove(lineNum);
			}
			this.Invalidate();
		}

		protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
		{
			base.OnPaint (e);

			// draw the breakpoints
			for (int i = 0; i < breakpoints.Count; i++)
			{
				e.Graphics.FillEllipse(System.Drawing.Brushes.DarkRed, 1,
					(int)breakpoints[i] * lineHeight + 3, 10, 10);
			}

		}

		public static bool isBreakpoint(int line)
		{
			return (breakpoints.Contains(line));
		}

		public static void disableInternal(int line)
		{
			if (breakpoints.Contains(line))
			{
				breakpoints.Remove(line);
				breakpoints.Add(-line);
			}
		}

		public static void EnableAll()
		{
			int line;
			for (int i = breakpoints.Count - 1; i >= 0; i--)
			{
				line = (int)breakpoints[i];
				if (line >= 0) continue;
				// ok breakpoint disable so enable it
				breakpoints.RemoveAt(i);
				breakpoints.Insert(i, -line);
			}
		}

		public static System.Collections.ArrayList bpList
		{
			get { return breakpoints; }
		}

	}
}
