/*
 * ::: Sunshine's Brainfuck Studio :::
 * 
 * Brainfuck Studio is a development environment for Brainfuck written in C#.
 * 
 * Version: 0.61 (April 2007)
 * 
 * Homepage: www.sunshine2k.de
 * EMail: webmaster@sunshine2k.de
 *
 *
 * LIMITATIONS:
 * - slow!	executing & syntax(!)
 * - only plaintext
 * - hardcoded till now: Memory : 30000 cells
 * - scrolling is fuck!!!
 * - UNDO does not work in richtextbox for me!!
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;



namespace BrainfuckStudio
{
	/**
	 * Summary Form1
	 **/
	public class Form1 : System.Windows.Forms.Form
	{
		#region Auto-Generated variables
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menu_Exit;
		private System.Windows.Forms.MenuItem menu_New;
		private System.Windows.Forms.MenuItem menu_Open;
		private System.Windows.Forms.MenuItem menu_Save;
		private System.Windows.Forms.MenuItem menu_SaveAs;
		private System.Windows.Forms.MenuItem menu_Close;
		private BrainfuckStudio.BfSourceTextBox SourceTextBox;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.NotifyIcon notifyIcon1;
		private System.Windows.Forms.ToolBarButton Sep1;
		private System.Windows.Forms.ToolBarButton StepButton;
		private BrainfuckStudio.VisualMemPanel MemPanel;
		private System.Windows.Forms.ContextMenu SourceBoxMenu;
		private System.Windows.Forms.ToolBarButton ExecuteButton;
		private System.Windows.Forms.ToolBarButton ResetButton;

		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel2;

		private BrainfuckStudio.MemoryBand	memBand;
		private System.Windows.Forms.Splitter SplitterBelowSourceBox;
		private System.Windows.Forms.Splitter SplitterLeftFromTable;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox OutputBox;
		private System.Windows.Forms.Button InputButton;
		private System.Windows.Forms.TextBox InputBox;

		private System.Windows.Forms.Label WaitForInputLabel;
		private System.Windows.Forms.ToolBarButton NewButton;
		private System.Windows.Forms.ToolBarButton OpenButton;
		private System.Windows.Forms.ToolBarButton SaveButton;
		private System.Windows.Forms.ToolBarButton SaveAsButton;
		private System.Windows.Forms.CheckBox AsNumberCheckBox;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menu_About;
		private System.Windows.Forms.ToolBarButton Sep2;

		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem Menu_View_MemTable;
		private System.Windows.Forms.MenuItem Menu_View_MemPanel;

		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menu_CheckBrackets;
		private System.Windows.Forms.ToolBarButton StopButton;

		private BrainfuckStudio.MemTable MemTable;

		private System.Windows.Forms.ToolBarButton RunToCursorButton;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menu_Cut;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menu_Copy;
		private System.Windows.Forms.MenuItem menu_Paste;
		private System.Windows.Forms.MenuItem menu_SelectAll;
		#endregion

		/***************************************************
		 ***** Own variables
		 **************************************************/

		// if we process a ',' command, this variable is true until
		// we get an input from the user
		private bool bWaitForInput = false;

		// set true if execution is paused
		private bool bExecutionPaused = false;

		// for currently opened file
		private string currentFileName = "";

		// filter for open/save dialog
		private string FilterString = "Brainfuck Source Files (*.b)|*.b|" +
			"All Files (*.*)|*.*";

		// hold if we are currently in single stepping mode
		private bool bStepMode = false;
		
		// reference to logger
		private Logger logger;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menu_Run;
		private System.Windows.Forms.MenuItem menu_Step;
		private System.Windows.Forms.MenuItem menu_RunToCursor;
		private System.Windows.Forms.MenuItem menu_PauseExec;
		private System.Windows.Forms.MenuItem menu_Restart;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menu_FileAssoc;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menu_Byte;
		private System.Windows.Forms.MenuItem menu_SByte;
		private System.Windows.Forms.MenuItem menu_Short;
		private System.Windows.Forms.MenuItem menu_SShort;
		private System.Windows.Forms.MenuItem menu_Int;
		private System.Windows.Forms.TabPage tabPage_Ascii;
		private System.Windows.Forms.TextBox AsciiTextBox;

		// some constants
		private const int EXECUTION_FINISHED = 1;

		// return values for function CloseFile()
		public enum CLOSE_RESULT  {SAVEDANDCLOSED, CLOSED, CANCEL, NOT_MODIFIED};

		/***************************************************
		 ***** END Own variables
		 **************************************************/


		/**
		 * Standard contructor of main window
		 **/
		public Form1()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			// create loglist
			logger = Logger.getLogger();
			this.tabControl1.TabPages[0].Controls.Add(logger.getListBox());

			SourceTextBox.parentForm = this;

			// create memory
			memBand = new MemoryBand(this.InputBox, this.OutputBox);

			// attach mempanel to memory
			memBand.Register(MemPanel);
			MemPanel.Memoryband = memBand;

			// attach memtable to memory
			memBand.Register(MemTable);
			MemTable.Memoryband = memBand;

			// init statusbar
			this.SourceTextBox.statusBar = this.statusBar1;

			// force to signal oberservers to draw themselves
			memBand.Notify();

			// show some info
			logger.LogWithTime("Sunshine's Brainfuck Studio started.");
		}

		public Form1(string[] cmdLine) : this()
		{
			this.LoadFile(cmdLine[0]);
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menu_New = new System.Windows.Forms.MenuItem();
			this.menu_Open = new System.Windows.Forms.MenuItem();
			this.menu_Save = new System.Windows.Forms.MenuItem();
			this.menu_SaveAs = new System.Windows.Forms.MenuItem();
			this.menu_Close = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menu_Exit = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menu_Cut = new System.Windows.Forms.MenuItem();
			this.menu_Copy = new System.Windows.Forms.MenuItem();
			this.menu_Paste = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menu_SelectAll = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menu_CheckBrackets = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menu_FileAssoc = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menu_Byte = new System.Windows.Forms.MenuItem();
			this.menu_SByte = new System.Windows.Forms.MenuItem();
			this.menu_Short = new System.Windows.Forms.MenuItem();
			this.menu_SShort = new System.Windows.Forms.MenuItem();
			this.menu_Int = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menu_Run = new System.Windows.Forms.MenuItem();
			this.menu_Step = new System.Windows.Forms.MenuItem();
			this.menu_RunToCursor = new System.Windows.Forms.MenuItem();
			this.menu_PauseExec = new System.Windows.Forms.MenuItem();
			this.menu_Restart = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.Menu_View_MemTable = new System.Windows.Forms.MenuItem();
			this.Menu_View_MemPanel = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menu_About = new System.Windows.Forms.MenuItem();
			this.SourceTextBox = new BrainfuckStudio.BfSourceTextBox();
			this.SourceBoxMenu = new System.Windows.Forms.ContextMenu();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.NewButton = new System.Windows.Forms.ToolBarButton();
			this.OpenButton = new System.Windows.Forms.ToolBarButton();
			this.SaveButton = new System.Windows.Forms.ToolBarButton();
			this.SaveAsButton = new System.Windows.Forms.ToolBarButton();
			this.Sep1 = new System.Windows.Forms.ToolBarButton();
			this.Sep2 = new System.Windows.Forms.ToolBarButton();
			this.ExecuteButton = new System.Windows.Forms.ToolBarButton();
			this.StepButton = new System.Windows.Forms.ToolBarButton();
			this.RunToCursorButton = new System.Windows.Forms.ToolBarButton();
			this.StopButton = new System.Windows.Forms.ToolBarButton();
			this.ResetButton = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.OutputBox = new System.Windows.Forms.TextBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.AsNumberCheckBox = new System.Windows.Forms.CheckBox();
			this.WaitForInputLabel = new System.Windows.Forms.Label();
			this.InputButton = new System.Windows.Forms.Button();
			this.InputBox = new System.Windows.Forms.TextBox();
			this.notifyIcon1 = new System.Windows.Forms.NotifyIcon(this.components);
			this.MemPanel = new BrainfuckStudio.VisualMemPanel();
			this.SplitterBelowSourceBox = new System.Windows.Forms.Splitter();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel2 = new System.Windows.Forms.StatusBarPanel();
			this.SplitterLeftFromTable = new System.Windows.Forms.Splitter();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.MemTable = new BrainfuckStudio.MemTable();
			this.panel2 = new System.Windows.Forms.Panel();
			this.tabPage_Ascii = new System.Windows.Forms.TabPage();
			this.AsciiTextBox = new System.Windows.Forms.TextBox();
			this.tabControl1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).BeginInit();
			this.panel2.SuspendLayout();
			this.tabPage_Ascii.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem5,
																					  this.menuItem4,
																					  this.menuItem6,
																					  this.menuItem2,
																					  this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_New,
																					  this.menu_Open,
																					  this.menu_Save,
																					  this.menu_SaveAs,
																					  this.menu_Close,
																					  this.menuItem7,
																					  this.menu_Exit});
			this.menuItem1.Text = "File";
			// 
			// menu_New
			// 
			this.menu_New.Index = 0;
			this.menu_New.Text = "New...";
			this.menu_New.Click += new System.EventHandler(this.menu_New_Click);
			// 
			// menu_Open
			// 
			this.menu_Open.Index = 1;
			this.menu_Open.Text = "Open...";
			this.menu_Open.Click += new System.EventHandler(this.menu_Open_Click);
			// 
			// menu_Save
			// 
			this.menu_Save.Index = 2;
			this.menu_Save.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.menu_Save.Text = "Save...";
			this.menu_Save.Click += new System.EventHandler(this.menu_Save_Click);
			// 
			// menu_SaveAs
			// 
			this.menu_SaveAs.Index = 3;
			this.menu_SaveAs.Text = "Save as...";
			this.menu_SaveAs.Click += new System.EventHandler(this.menu_SaveAs_Click);
			// 
			// menu_Close
			// 
			this.menu_Close.Index = 4;
			this.menu_Close.Text = "Close";
			this.menu_Close.Click += new System.EventHandler(this.menu_Close_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 5;
			this.menuItem7.Text = "-";
			// 
			// menu_Exit
			// 
			this.menu_Exit.Index = 6;
			this.menu_Exit.Text = "Exit";
			this.menu_Exit.Click += new System.EventHandler(this.menu_Exit_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_Cut,
																					  this.menu_Copy,
																					  this.menu_Paste,
																					  this.menuItem11,
																					  this.menu_SelectAll});
			this.menuItem5.Text = "Edit";
			// 
			// menu_Cut
			// 
			this.menu_Cut.Index = 0;
			this.menu_Cut.Text = "Cut";
			this.menu_Cut.Click += new System.EventHandler(this.menu_Cut_Click);
			// 
			// menu_Copy
			// 
			this.menu_Copy.Index = 1;
			this.menu_Copy.Text = "Copy";
			this.menu_Copy.Click += new System.EventHandler(this.menu_Copy_Click);
			// 
			// menu_Paste
			// 
			this.menu_Paste.Index = 2;
			this.menu_Paste.Text = "Paste";
			this.menu_Paste.Click += new System.EventHandler(this.menu_Paste_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 3;
			this.menuItem11.Text = "-";
			// 
			// menu_SelectAll
			// 
			this.menu_SelectAll.Index = 4;
			this.menu_SelectAll.Text = "Select All";
			this.menu_SelectAll.Click += new System.EventHandler(this.menu_SelectAll_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_CheckBrackets,
																					  this.menuItem8,
																					  this.menu_FileAssoc,
																					  this.menuItem9});
			this.menuItem4.Text = "Options";
			// 
			// menu_CheckBrackets
			// 
			this.menu_CheckBrackets.Index = 0;
			this.menu_CheckBrackets.Text = "Check Brackets before Executing";
			this.menu_CheckBrackets.Click += new System.EventHandler(this.menu_CheckBrackets_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 1;
			this.menuItem8.Text = "-";
			// 
			// menu_FileAssoc
			// 
			this.menu_FileAssoc.Index = 2;
			this.menu_FileAssoc.Text = "File Associations...";
			this.menu_FileAssoc.Click += new System.EventHandler(this.menu_FileAssoc_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 3;
			this.menuItem9.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_Byte,
																					  this.menu_SByte,
																					  this.menu_Short,
																					  this.menu_SShort,
																					  this.menu_Int});
			this.menuItem9.Text = "Memory Cells Datatype...";
			// 
			// menu_Byte
			// 
			this.menu_Byte.Index = 0;
			this.menu_Byte.RadioCheck = true;
			this.menu_Byte.Text = "Byte (0...255)";
			this.menu_Byte.Click += new System.EventHandler(this.menu_Byte_Click);
			// 
			// menu_SByte
			// 
			this.menu_SByte.Index = 1;
			this.menu_SByte.RadioCheck = true;
			this.menu_SByte.Text = "Signed Byte (-128...127)";
			this.menu_SByte.Click += new System.EventHandler(this.menu_SByte_Click);
			// 
			// menu_Short
			// 
			this.menu_Short.Index = 2;
			this.menu_Short.RadioCheck = true;
			this.menu_Short.Text = "Short (0...65536)";
			this.menu_Short.Click += new System.EventHandler(this.menu_Short_Click);
			// 
			// menu_SShort
			// 
			this.menu_SShort.Index = 3;
			this.menu_SShort.RadioCheck = true;
			this.menu_SShort.Text = "Signed Short (-32768...32767)";
			this.menu_SShort.Click += new System.EventHandler(this.menu_SShort_Click);
			// 
			// menu_Int
			// 
			this.menu_Int.Checked = true;
			this.menu_Int.Index = 4;
			this.menu_Int.RadioCheck = true;
			this.menu_Int.Text = "Integer (-2^31...2^31-1)";
			this.menu_Int.Click += new System.EventHandler(this.menu_Int_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 3;
			this.menuItem6.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_Run,
																					  this.menu_Step,
																					  this.menu_RunToCursor,
																					  this.menu_PauseExec,
																					  this.menu_Restart});
			this.menuItem6.Text = "Programm";
			// 
			// menu_Run
			// 
			this.menu_Run.Index = 0;
			this.menu_Run.Text = "Run...";
			this.menu_Run.Click += new System.EventHandler(this.menu_Run_Click);
			// 
			// menu_Step
			// 
			this.menu_Step.Index = 1;
			this.menu_Step.Text = "Step...";
			this.menu_Step.Click += new System.EventHandler(this.menu_Step_Click);
			// 
			// menu_RunToCursor
			// 
			this.menu_RunToCursor.Index = 2;
			this.menu_RunToCursor.Text = "Run to cursor...";
			this.menu_RunToCursor.Click += new System.EventHandler(this.menu_RunToCursor_Click);
			// 
			// menu_PauseExec
			// 
			this.menu_PauseExec.Index = 3;
			this.menu_PauseExec.Text = "Pause Execution...";
			this.menu_PauseExec.Click += new System.EventHandler(this.menu_PauseExec_Click);
			// 
			// menu_Restart
			// 
			this.menu_Restart.Index = 4;
			this.menu_Restart.Text = "Restart...";
			this.menu_Restart.Click += new System.EventHandler(this.menu_Restart_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 4;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.Menu_View_MemTable,
																					  this.Menu_View_MemPanel});
			this.menuItem2.Text = "View";
			// 
			// Menu_View_MemTable
			// 
			this.Menu_View_MemTable.Checked = true;
			this.Menu_View_MemTable.Index = 0;
			this.Menu_View_MemTable.Text = "Memory Table";
			this.Menu_View_MemTable.Click += new System.EventHandler(this.Menu_View_MemTable_Click);
			// 
			// Menu_View_MemPanel
			// 
			this.Menu_View_MemPanel.Checked = true;
			this.Menu_View_MemPanel.Index = 1;
			this.Menu_View_MemPanel.Text = "Memory Panel";
			this.Menu_View_MemPanel.Click += new System.EventHandler(this.Menu_View_MemPanel_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 5;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menu_About});
			this.menuItem3.Text = "Info";
			// 
			// menu_About
			// 
			this.menu_About.Index = 0;
			this.menu_About.Text = "About...";
			this.menu_About.Click += new System.EventHandler(this.menu_About_Click);
			// 
			// SourceTextBox
			// 
			this.SourceTextBox.AcceptsTab = true;
			this.SourceTextBox.AllowDrop = true;
			this.SourceTextBox.BackColor = System.Drawing.Color.Silver;
			this.SourceTextBox.DetectUrls = false;
			this.SourceTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.SourceTextBox.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.SourceTextBox.Location = new System.Drawing.Point(0, 0);
			this.SourceTextBox.Name = "SourceTextBox";
			this.SourceTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Vertical;
			this.SourceTextBox.Size = new System.Drawing.Size(389, 111);
			this.SourceTextBox.TabIndex = 0;
			this.SourceTextBox.Text = "";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.NewButton,
																						this.OpenButton,
																						this.SaveButton,
																						this.SaveAsButton,
																						this.Sep1,
																						this.Sep2,
																						this.ExecuteButton,
																						this.StepButton,
																						this.RunToCursorButton,
																						this.StopButton,
																						this.ResetButton});
			this.toolBar1.ButtonSize = new System.Drawing.Size(32, 32);
			this.toolBar1.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(592, 44);
			this.toolBar1.TabIndex = 2;
			this.toolBar1.Wrappable = false;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// NewButton
			// 
			this.NewButton.ImageIndex = 1;
			this.NewButton.Text = "New";
			this.NewButton.ToolTipText = "New File";
			// 
			// OpenButton
			// 
			this.OpenButton.ImageIndex = 0;
			this.OpenButton.ToolTipText = "Open File...";
			// 
			// SaveButton
			// 
			this.SaveButton.ImageIndex = 2;
			this.SaveButton.ToolTipText = "Save File...";
			// 
			// SaveAsButton
			// 
			this.SaveAsButton.ImageIndex = 3;
			this.SaveAsButton.ToolTipText = "Save File As...";
			// 
			// Sep1
			// 
			this.Sep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// Sep2
			// 
			this.Sep2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// ExecuteButton
			// 
			this.ExecuteButton.ImageIndex = 4;
			this.ExecuteButton.Text = "Execute";
			this.ExecuteButton.ToolTipText = "Execute";
			// 
			// StepButton
			// 
			this.StepButton.ImageIndex = 5;
			this.StepButton.Text = "Step";
			this.StepButton.ToolTipText = "Step into...";
			// 
			// RunToCursorButton
			// 
			this.RunToCursorButton.ImageIndex = 6;
			this.RunToCursorButton.Text = "-> |";
			this.RunToCursorButton.ToolTipText = "Run to cursor...";
			// 
			// StopButton
			// 
			this.StopButton.ImageIndex = 8;
			this.StopButton.Text = "X";
			this.StopButton.ToolTipText = "Interrupt Execution";
			// 
			// ResetButton
			// 
			this.ResetButton.ImageIndex = 7;
			this.ResetButton.Text = "<<";
			this.ResetButton.ToolTipText = "Reset";
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(32, 32);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.White;
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Controls.Add(this.tabPage_Ascii);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.tabControl1.Location = new System.Drawing.Point(0, 297);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(389, 176);
			this.tabControl1.TabIndex = 3;
			// 
			// tabPage1
			// 
			this.tabPage1.BackColor = System.Drawing.SystemColors.ActiveBorder;
			this.tabPage1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(381, 150);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Status";
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.OutputBox);
			this.tabPage2.Controls.Add(this.panel1);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(381, 150);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Output";
			this.tabPage2.ToolTipText = "\"Output of programm\"";
			// 
			// OutputBox
			// 
			this.OutputBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.OutputBox.Enabled = false;
			this.OutputBox.Location = new System.Drawing.Point(0, 0);
			this.OutputBox.Multiline = true;
			this.OutputBox.Name = "OutputBox";
			this.OutputBox.ReadOnly = true;
			this.OutputBox.Size = new System.Drawing.Size(381, 118);
			this.OutputBox.TabIndex = 1;
			this.OutputBox.Text = "";
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.Add(this.AsNumberCheckBox);
			this.panel1.Controls.Add(this.WaitForInputLabel);
			this.panel1.Controls.Add(this.InputButton);
			this.panel1.Controls.Add(this.InputBox);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 118);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(381, 32);
			this.panel1.TabIndex = 0;
			// 
			// AsNumberCheckBox
			// 
			this.AsNumberCheckBox.Location = new System.Drawing.Point(184, 4);
			this.AsNumberCheckBox.Name = "AsNumberCheckBox";
			this.AsNumberCheckBox.TabIndex = 3;
			this.AsNumberCheckBox.Text = "as Number";
			// 
			// WaitForInputLabel
			// 
			this.WaitForInputLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.WaitForInputLabel.ForeColor = System.Drawing.Color.Firebrick;
			this.WaitForInputLabel.Location = new System.Drawing.Point(304, 8);
			this.WaitForInputLabel.Name = "WaitForInputLabel";
			this.WaitForInputLabel.Size = new System.Drawing.Size(100, 16);
			this.WaitForInputLabel.TabIndex = 2;
			// 
			// InputButton
			// 
			this.InputButton.Location = new System.Drawing.Point(120, 4);
			this.InputButton.Name = "InputButton";
			this.InputButton.Size = new System.Drawing.Size(48, 20);
			this.InputButton.TabIndex = 1;
			this.InputButton.Text = "OK";
			this.InputButton.Click += new System.EventHandler(this.InputButton_Click);
			// 
			// InputBox
			// 
			this.InputBox.Location = new System.Drawing.Point(8, 4);
			this.InputBox.Name = "InputBox";
			this.InputBox.TabIndex = 0;
			this.InputBox.Text = "";
			// 
			// notifyIcon1
			// 
			this.notifyIcon1.Text = "notifyIcon1";
			this.notifyIcon1.Visible = true;
			// 
			// MemPanel
			// 
			this.MemPanel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.MemPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.MemPanel.Location = new System.Drawing.Point(0, 158);
			this.MemPanel.Name = "MemPanel";
			this.MemPanel.Size = new System.Drawing.Size(389, 136);
			this.MemPanel.TabIndex = 4;
			// 
			// SplitterBelowSourceBox
			// 
			this.SplitterBelowSourceBox.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.SplitterBelowSourceBox.Location = new System.Drawing.Point(0, 155);
			this.SplitterBelowSourceBox.Name = "SplitterBelowSourceBox";
			this.SplitterBelowSourceBox.Size = new System.Drawing.Size(389, 3);
			this.SplitterBelowSourceBox.TabIndex = 5;
			this.SplitterBelowSourceBox.TabStop = false;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 473);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanel1,
																						  this.statusBarPanel2});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(392, 22);
			this.statusBar1.SizingGrip = false;
			this.statusBar1.TabIndex = 6;
			this.statusBar1.Text = "statusBar1";
			// 
			// statusBarPanel1
			// 
			this.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel1.MinWidth = 100;
			this.statusBarPanel1.Width = 192;
			// 
			// statusBarPanel2
			// 
			this.statusBarPanel2.Width = 200;
			// 
			// SplitterLeftFromTable
			// 
			this.SplitterLeftFromTable.Dock = System.Windows.Forms.DockStyle.Right;
			this.SplitterLeftFromTable.Location = new System.Drawing.Point(389, 44);
			this.SplitterLeftFromTable.Name = "SplitterLeftFromTable";
			this.SplitterLeftFromTable.Size = new System.Drawing.Size(3, 429);
			this.SplitterLeftFromTable.TabIndex = 7;
			this.SplitterLeftFromTable.TabStop = false;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 294);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(389, 3);
			this.splitter1.TabIndex = 8;
			this.splitter1.TabStop = false;
			// 
			// MemTable
			// 
			this.MemTable.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.MemTable.Dock = System.Windows.Forms.DockStyle.Right;
			this.MemTable.Location = new System.Drawing.Point(392, 44);
			this.MemTable.Name = "MemTable";
			this.MemTable.Size = new System.Drawing.Size(200, 451);
			this.MemTable.TabIndex = 9;
			this.MemTable.TabStop = true;
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.SourceTextBox);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 44);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(389, 111);
			this.panel2.TabIndex = 10;
			// 
			// tabPage_Ascii
			// 
			this.tabPage_Ascii.Controls.Add(this.AsciiTextBox);
			this.tabPage_Ascii.Location = new System.Drawing.Point(4, 22);
			this.tabPage_Ascii.Name = "tabPage_Ascii";
			this.tabPage_Ascii.Size = new System.Drawing.Size(381, 150);
			this.tabPage_Ascii.TabIndex = 2;
			this.tabPage_Ascii.Text = "Ascii Table";
			// 
			// AsciiTextBox
			// 
			this.AsciiTextBox.BackColor = System.Drawing.SystemColors.Control;
			this.AsciiTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.AsciiTextBox.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.AsciiTextBox.Location = new System.Drawing.Point(0, 0);
			this.AsciiTextBox.Multiline = true;
			this.AsciiTextBox.Name = "AsciiTextBox";
			this.AsciiTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.AsciiTextBox.Size = new System.Drawing.Size(381, 150);
			this.AsciiTextBox.TabIndex = 0;
			this.AsciiTextBox.Text = " Dec      Oct    Hex   Binary        Value\r\n ---      ---    ---   --------      " +
				"---\r\n 000      000    000   00000000      NUL    (Null char.)\r\n 001      001    " +
				"001   00000001      SOH    (Start of Header)\r\n 002      002    002   00000010   " +
				"   STX    (Start of Text)\r\n 003      003    003   00000011      ETX    (End of T" +
				"ext)\r\n 004      004    004   00000100      EOT    (End of Transmission)\r\n 005   " +
				"   005    005   00000101      ENQ    (Enquiry)\r\n 006      006    006   00000110 " +
				"     ACK    (Acknowledgment)\r\n 007      007    007   00000111      BEL    (Bell)" +
				"\r\n 008      010    008   00001000       BS    (Backspace)\r\n 009      011    009 " +
				"  00001001       HT    (Horizontal Tab)\r\n 010      012    00A   00001010       L" +
				"F    (Line Feed)\r\n 011      013    00B   00001011       VT    (Vertical Tab)\r\n 0" +
				"12      014    00C   00001100       FF    (Form Feed)\r\n 013      015    00D   00" +
				"001101       CR    (Carriage Return)\r\n 014      016    00E   00001110       SO  " +
				"  (Shift Out)\r\n 015      017    00F   00001111       SI    (Shift In)\r\n 016     " +
				" 020    010   00010000      DLE    (Data Link Escape)\r\n 017      021    011   00" +
				"010001      DC1    (XON) (Device Control 1)\r\n 018      022    012   00010010    " +
				"  DC2       (Device Control 2)\r\n 019      023    013   00010011      DC3    (XOF" +
				"F)(Device Control 3)\r\n 020      024    014   00010100      DC4       (Device Con" +
				"trol 4)\r\n 021      025    015   00010101      NAK    (Negative Acknowledgement)\r" +
				"\n 022      026    016   00010110      SYN    (Synchronous Idle)\r\n 023      027  " +
				"  017   00010111      ETB    (End of Trans. Block)\r\n 024      030    018   00011" +
				"000      CAN    (Cancel)\r\n 025      031    019   00011001       EM    (End of Me" +
				"dium)\r\n 026      032    01A   00011010      SUB    (Substitute)\r\n 027      033  " +
				"  01B   00011011      ESC    (Escape)\r\n 028      034    01C   00011100       FS " +
				"   (File Separator)\r\n 029      035    01D   00011101       GS    (Group Separato" +
				"r)\r\n 030      036    01E   00011110       RS    (Request to Send)(Record Separat" +
				"or)\r\n 031      037    01F   00011111       US    (Unit Separator)\r\n 032      040" +
				"    020   00100000       SP    (Space)\r\n 033      041    021   00100001        !" +
				"    (exclamation mark)\r\n 034      042    022   00100010        \"    (double quot" +
				"e)\r\n 035      043    023   00100011        #    (number sign)\r\n 036      044    " +
				"024   00100100        $    (dollar sign)\r\n 037      045    025   00100101       " +
				" %    (percent)\r\n 038      046    026   00100110        &    (ampersand)\r\n 039  " +
				"    047    027   00100111        \'    (single quote)\r\n 040      050    028   001" +
				"01000        (    (left/opening parenthesis)\r\n 041      051    029   00101001   " +
				"     )    (right/closing parenthesis)\r\n 042      052    02A   00101010        * " +
				"   (asterisk)\r\n 043      053    02B   00101011        +    (plus)\r\n 044      054" +
				"    02C   00101100        ,    (comma)\r\n 045      055    02D   00101101        -" +
				"    (minus or dash)\r\n 046      056    02E   00101110        .    (dot)\r\n 047    " +
				"  057    02F   00101111        /    (forward slash)\r\n 048      060    030   0011" +
				"0000        0\r\n 049      061    031   00110001        1\r\n 050      062    032   " +
				"00110010        2\r\n 051      063    033   00110011        3\r\n 052      064    03" +
				"4   00110100        4\r\n 053      065    035   00110101        5\r\n 054      066  " +
				"  036   00110110        6\r\n 055      067    037   00110111        7\r\n 056      0" +
				"70    038   00111000        8\r\n 057      071    039   00111001        9\r\n 058   " +
				"   072    03A   00111010        :    (colon)\r\n 059      073    03B   00111011   " +
				"     ;    (semi-colon)\r\n 060      074    03C   00111100        <    (less than)\r" +
				"\n 061      075    03D   00111101        =    (equal sign)\r\n 062      076    03E " +
				"  00111110        >    (greater than)\r\n 063      077    03F   00111111        ? " +
				"   (question mark)\r\n 064      100    040   01000000        @    (AT symbol)\r\n 06" +
				"5      101    041   01000001        A\r\n 066      102    042   01000010        B\r" +
				"\n 067      103    043   01000011        C\r\n 068      104    044   01000100      " +
				"  D\r\n 069      105    045   01000101        E\r\n 070      106    046   01000110  " +
				"      F\r\n 071      107    047   01000111        G\r\n 072      110    048   010010" +
				"00        H\r\n 073      111    049   01001001        I\r\n 074      112    04A   01" +
				"001010        J\r\n 075      113    04B   01001011        K\r\n 076      114    04C " +
				"  01001100        L\r\n 077      115    04D   01001101        M\r\n 078      116    " +
				"04E   01001110        N\r\n 079      117    04F   01001111        O\r\n 080      120" +
				"    050   01010000        P\r\n 081      121    051   01010001        Q\r\n 082     " +
				" 122    052   01010010        R\r\n 083      123    053   01010011        S\r\n 084 " +
				"     124    054   01010100        T\r\n 085      125    055   01010101        U\r\n " +
				"086      126    056   01010110        V\r\n 087      127    057   01010111        " +
				"W\r\n 088      130    058   01011000        X\r\n 089      131    059   01011001    " +
				"    Y\r\n 090      132    05A   01011010        Z\r\n 091      133    05B   01011011" +
				"        [    (left/opening bracket)\r\n 092      134    05C   01011100        \\   " +
				" (back slash)\r\n 093      135    05D   01011101        ]    (right/closing bracke" +
				"t)\r\n 094      136    05E   01011110        ^    (caret/circumflex)\r\n 095      13" +
				"7    05F   01011111        _    (underscore)\r\n 096      140    060   01100000   " +
				"     `\r\n 097      141    061   01100001        a\r\n 098      142    062   0110001" +
				"0        b\r\n 099      143    063   01100011        c\r\n 100      144    064   011" +
				"00100        d\r\n 101      145    065   01100101        e\r\n 102      146    066  " +
				" 01100110        f\r\n 103      147    067   01100111        g\r\n 104      150    0" +
				"68   01101000        h\r\n 105      151    069   01101001        i\r\n 106      152 " +
				"   06A   01101010        j\r\n 107      153    06B   01101011        k\r\n 108      " +
				"154    06C   01101100        l\r\n 109      155    06D   01101101        m\r\n 110  " +
				"    156    06E   01101110        n\r\n 111      157    06F   01101111        o\r\n 1" +
				"12      160    070   01110000        p\r\n 113      161    071   01110001        q" +
				"\r\n 114      162    072   01110010        r\r\n 115      163    073   01110011     " +
				"   s\r\n 116      164    074   01110100        t\r\n 117      165    075   01110101 " +
				"       u\r\n 118      166    076   01110110        v\r\n 119      167    077   01110" +
				"111        w\r\n 120      170    078   01111000        x\r\n 121      171    079   0" +
				"1111001        y\r\n 122      172    07A   01111010        z\r\n 123      173    07B" +
				"   01111011        {    (left/opening brace)\r\n 124      174    07C   01111100   " +
				"     |    (vertical bar)\r\n 125      175    07D   01111101        }    (right/clo" +
				"sing brace)\r\n 126      176    07E   01111110        ~    (tilde)\r\n 127      177 " +
				"   07F   01111111      DEL    (delete)";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 495);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.SplitterBelowSourceBox);
			this.Controls.Add(this.MemPanel);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.SplitterLeftFromTable);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.MemTable);
			this.Controls.Add(this.toolBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Sunshine\'s Brainfuck Studio";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.tabControl1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).EndInit();
			this.panel2.ResumeLayout(false);
			this.tabPage_Ascii.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main(string[] cmdLine)
		{
			if (cmdLine.Length == 0)
			{
				Application.Run(new Form1());
			}
			else
			{
				Application.Run(new Form1(cmdLine));
			}
		}

		
		/**
		 * Load source file
		 **/
		public void LoadFile(string filename)
		{
			try
			{
				SourceTextBox.LoadSourceFile(filename, RichTextBoxStreamType.PlainText);
				currentFileName = filename;
				this.statusBar1.Panels[0].Text = currentFileName;
				logger.LogWithTime(currentFileName + " succesfully loaded.");
			}
			catch (System.IO.IOException ex)
			{
				logger.LogWithTime("Loading failed. " + ex.Message);
			}
		}


		/**
		 * Handle the button clicks on the toolbar
		 **/
		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			// redirect clicks
			if (e.Button == OpenButton)
				menu_Open.PerformClick();

			if (e.Button == NewButton)
				this.menu_New.PerformClick();

			if (e.Button == SaveButton)
				this.menu_Save.PerformClick();

			if (e.Button == SaveAsButton)
				this.menu_SaveAs.PerformClick();



			// just execute one command
			if (e.Button == StepButton)
			{
				// TO DO: make sourcebox readonly while executing
				bStepMode = true;
				//SourceTextBox.ReadOnly = true;
				BfSourceTextBox.bReactOnChanging = false;
				ExecuteStep();
				BfSourceTextBox.bReactOnChanging = true;
			}

			// execute whole programm from beginning
			if (e.Button == ExecuteButton)
			{
				// check if we just resume and not start from scratch
				if (bExecutionPaused)
				{
					bExecutionPaused = false;
					Execute();
					return;
				}

				Reset();

				// should we check for brackets validity?
				if (this.menu_CheckBrackets.Checked)
				{
					if (!SourceTextBox.CheckBrackets())
					{
						logger.LogErrorWithTime("Brackets invalid!");
						return;
					}
				}

				logger.LogWithTime("Execution started....");
				

				// disable buttons
				this.ExecuteButton.Enabled = false;
				this.StepButton.Enabled = false;
				this.ResetButton.Enabled = false;
				this.RunToCursorButton.Enabled = false;
				SourceTextBox.ReadOnly = true;
				
				Execute();
				
				// enable buttons
				this.ExecuteButton.Enabled = true;
				this.StepButton.Enabled = true;
				this.ResetButton.Enabled = true;
				this.RunToCursorButton.Enabled = true;
				SourceTextBox.ReadOnly = false;

				//bForceExecutionStop = false;
				
			}

			// reset everything
			if (e.Button == ResetButton)
			{
				Reset();
				SourceTextBox.ReadOnly = false;
				
				BfSourceTextBox.bPaint = false;
				BfSourceTextBox.bReactOnChanging = false;
				SourceTextBox.ParseRichTextBox();				// ! -> just one line?
				BfSourceTextBox.bReactOnChanging = true;
				BfSourceTextBox.bPaint = true;
			}

			// run to cursor
			if (e.Button == RunToCursorButton)
			{
				// get cursor position in sourcebox
				int charPos = SourceTextBox.SelectionStart;

				while (SourceTextBox.Position < charPos)
					ExecuteStep();
			}

			// stop execution
			if (e.Button == this.StopButton)
			{
				bExecutionPaused = true;
			}
		}


		/**
		 * Reset all values to standard values
		 **/
		private void Reset()
		{
			bWaitForInput = false;
			memBand.Reset();
			SourceTextBox.PrepeareForExecution();
			OutputBox.Clear();
			this.WaitForInputLabel.Text = "";
			logger.LogWithTime("Memory cells reseted.");
			if (bStepMode)
				logger.LogWithTime("Leaving Single stepping mode...");
			bStepMode = false;  

			this.ExecuteButton.Enabled = true;
			this.StepButton.Enabled = true;
			bExecutionPaused = false;
		}


		/// <summary>
		/// Execute one brainfuck command and wait
		/// </summary>
		private void ExecuteStep()
		{
			// don't do anything until we get some valid input
			if (this.bWaitForInput) return;
			// end reached? nothing to do any more
			if (SourceTextBox.Position == SourceTextBox.TextLength) 
			{
				logger.LogWithTime("File Execution finished : " + memBand.NumberOfCommands +
					" commands executed.");
				return;
			}

			// switch to brainfuck tabpage
			this.tabControl1.SelectedIndex = 1;

			// get next command
			char c = SourceTextBox.getNextCommand();

			// process next command
			int result = memBand.InterpretCommand(c);
			// handle jumps
			if (result == MemoryBand.STATUS_JUMPOUT)
			{
				// we have to jump after the next ']'
				if (!SourceTextBox.goToClosingBracket())
					logger.LogWithTime("Unbalanced brackets!");
			}
			else if (result == MemoryBand.STATUS_JUMPLOOP)
			{
				// we have to jump back to the corresponding '['
				if (!SourceTextBox.goToOpeningBracket())
					logger.LogWithTime("Unbalanced brackets!");
			}
			// we need some input
			else if (result == MemoryBand.STATUS_INPUTREQUIRED)
			{
				this.bWaitForInput = true;
				this.WaitForInputLabel.Text = "Input required!";
				this.InputBox.Focus();
			}

			// mark next command
			if (result == MemoryBand.STATUS_INPUTREQUIRED)
				SourceTextBox.markCurrentCommand();
			else
			{
				SourceTextBox.unmarkCurrentCommand();
				SourceTextBox.markNextCommand();	
			}
			SourceTextBox.Focus();

			// check if execution is finished
			if (SourceTextBox.Position == SourceTextBox.TextLength)
				logger.LogWithTime("File Execution finished : " + memBand.NumberOfCommands +
					" commands executed.");
		}


		/**
		 * Execute bf source from current position;
		 * Returns if an input command or the end is reached
		 **/
		public void Execute()
		{
			// don't do anything until we get some valid input
			if (this.bWaitForInput) return;

			SourceTextBox.Focus();

			// switch to brainfuck tabpage
			this.tabControl1.SelectedIndex = 1;

			// memory band should not notify oberservs while execution
			memBand.bDisableNotify = true;

			DateTime start = DateTime.Now;

			// start execution
			while (SourceTextBox.Position < SourceTextBox.TextLength)
			{
				// stop button was pressed
				if (bExecutionPaused) break;

				char c = SourceTextBox.getNextCommand();
				int result = memBand.InterpretCommand(c);

				// if it was a user input, get it and stop
				if (result == MemoryBand.STATUS_JUMPOUT)
				{
					// we have to jump after the next ']'
					if (!SourceTextBox.goToClosingBracket())
					{
						logger.LogWithTime("ERROR: Unbalanced brackets!");
						this.OutputBox.AppendText("ERROR: Unbalenced brackets!");
					}
				}
				else if (result == MemoryBand.STATUS_JUMPLOOP)
				{
					if (!SourceTextBox.goToOpeningBracket())
					{
						logger.LogWithTime("Unbalanced brackets");
						this.OutputBox.AppendText("ERROR: Unbalenced brackets!");
					}
				}
				// we need some input
				else if (result == MemoryBand.STATUS_INPUTREQUIRED)
				{
					SourceTextBox.markCurrentCommand();
					this.bWaitForInput = true;
					this.WaitForInputLabel.Text = "Input required!";
					this.InputBox.Focus();
					break;
				}
				Application.DoEvents();
			}

			memBand.bDisableNotify = false;
			memBand.Notify();

			// check if execution is finished
			if ((SourceTextBox.Position == SourceTextBox.TextLength))
			{
				logger.LogWithTime("File Execution finished : " + memBand.NumberOfCommands +
					" commands executed.");
				TimeSpan elapsed = DateTime.Now - start;
				logger.LogWithTime("   > Time: " + elapsed.TotalSeconds +" s   (Commands/sec : " 
					+ (int)memBand.NumberOfCommands/elapsed.TotalSeconds + ")");
			}
			else if (bExecutionPaused)
			{
				TimeSpan elapsed = DateTime.Now - start;
				logger.LogWithTime("File Execution interrupted... Processed " + memBand.NumberOfCommands + " commands.");
				logger.LogWithTime("   > Time: " + elapsed.TotalSeconds +" s   (Commands/sec : " 
					+ (int)memBand.NumberOfCommands/elapsed.TotalSeconds + ")");
			}
		}

		/**
		 * Close current file; before ask user to save it
		 **/
		public CLOSE_RESULT CloseFile()
		{
			//this.menu_New.PerformClick();
			if (SourceTextBox.Modified)
			{
				DialogResult Dlgresult;
				// ask user if file should be saved
				Dlgresult = MessageBox.Show(this, "Do you want to save current file?",
					"File was modified!", MessageBoxButtons.YesNoCancel,
					MessageBoxIcon.Question,MessageBoxDefaultButton.Button3);

				if (Dlgresult == DialogResult.Yes)
				{
					// see if we have to create a new file
					if (this.currentFileName == "")
						menu_SaveAs.PerformClick();
					else
						menu_Save.PerformClick();

					this.currentFileName = "";
					SourceTextBox.Clear();
					memBand.Reset();
					logger.LogWithTime("File saved and closed.");
					return CLOSE_RESULT.SAVEDANDCLOSED;
				}
				else if (Dlgresult == DialogResult.No)
				{
					this.currentFileName = "";
					SourceTextBox.Clear();
					memBand.Reset();
					logger.LogWithTime("File closed.");
					return CLOSE_RESULT.CLOSED;
				}
				else //if (Dlgresult == DialogResult.Cancel)
					return CLOSE_RESULT.CANCEL;

			}
			else
				return CLOSE_RESULT.NOT_MODIFIED;
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			this.toolBar1.Width = this.Width;
		}

		/// <summary>
		/// Read input and write it to current cell
		/// </summary>
		private void InputButton_Click(object sender, System.EventArgs e)
		{
			// when we are not waiting for input, ignore it
			if (!this.bWaitForInput) return;

			if (this.AsNumberCheckBox.Checked)
			{
				// read input as number
				int input;
				try
				{
					input = int.Parse(InputBox.Text);
				}
				catch (Exception ex)
				{
					logger.LogWithTime("Error: No valid number. " + ex.Message);
					InputBox.Text = "";
					return;
				}
				memBand.Memory[memBand.CurrentPos] = input;
			}
			else
			{
				// we just take the first char! (ignore the possible rest of the string)
				memBand.Memory[memBand.CurrentPos] = this.InputBox.Text[0];
			}
			this.bWaitForInput = false;
			this.WaitForInputLabel.Text = "";

			// make input visible
			memBand.Notify();


			if (this.bStepMode)
			{
				SourceTextBox.markNextCommand();
			}
			else
				ContinueExecution();

		}


		/**
		 * Continue execution from current position.
		 * Note that bWaitForInput is NOT checked.
		 **/
		public void ContinueExecution()
		{
			memBand.bDisableNotify = true;	// no update while executing
			
			DateTime start = DateTime.Now;

			while (SourceTextBox.Position < SourceTextBox.TextLength)
			{
				// stop button was pressed
				if (bExecutionPaused) break;

				char c = SourceTextBox.getNextCommand();
				int result = memBand.InterpretCommand(c);

				// if it was a user input, get it and stop
				if (result == MemoryBand.STATUS_JUMPOUT)
				{
					// we have to jump after the next ']'
					if (!SourceTextBox.goToClosingBracket())
						logger.LogWithTime("Unbalanced brackets");
				}
				else if (result == MemoryBand.STATUS_JUMPLOOP)
				{
					if (!SourceTextBox.goToOpeningBracket())
						logger.LogWithTime("Unbalanced brackets");
				}
				// we need some input
				else if (result == MemoryBand.STATUS_INPUTREQUIRED)
				{
					SourceTextBox.markCurrentCommand();
					this.bWaitForInput = true;
					this.WaitForInputLabel.Text = "Input required!";
					this.InputBox.Focus();
					break;
				}
			}

			// check if execution is finished
			if ((SourceTextBox.Position == SourceTextBox.TextLength))
			{
				logger.LogWithTime("File Execution finished : " + memBand.NumberOfCommands +
					" commands executed.");
				TimeSpan elapsed = DateTime.Now - start;
				logger.LogWithTime("   > Time: " + elapsed.TotalSeconds +" s   (Commands/sec : " 
					+ (int)memBand.NumberOfCommands/elapsed.TotalSeconds + ")");
			}
			else if (bExecutionPaused)
			{
				TimeSpan elapsed = DateTime.Now - start;
				logger.LogWithTime("File Execution interrupted... Processed " + memBand.NumberOfCommands + " commands.");
				logger.LogWithTime("   > Time: " + elapsed.TotalSeconds +" s   (Commands/sec : " 
					+ (int)memBand.NumberOfCommands/elapsed.TotalSeconds + ")");
			}

			memBand.bDisableNotify = false;
			memBand.Notify();
		}

		
		
		/**************************************************
		 * Menu & buttons click handling
		 **************************************************/
		#region ClickHandling

		/**
		 * Closes current file
		 **/
		private void menu_Close_Click(object sender, System.EventArgs e)
		{
			CloseFile();
		}

		/**
		 * Save file; prompt file folder box for user input
		 **/
		private void menu_SaveAs_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog sfd = new SaveFileDialog();
			sfd.Filter = FilterString;
			sfd.FilterIndex = 0;

			if (sfd.ShowDialog() == DialogResult.OK)
			{
				// TO DO : File exception
				SourceTextBox.SaveSourceFile(sfd.FileName, RichTextBoxStreamType.PlainText);
				this.currentFileName = sfd.FileName;
				statusBar1.Panels[0].Text = this.currentFileName;
				logger.LogWithTime("File saved: " + currentFileName);
			}
		}

		/**
		 * Save file; if no filename, prompt file folder box
		 **/
		private void menu_Save_Click(object sender, System.EventArgs e)
		{
			if (this.currentFileName == "")
				menu_SaveAs.PerformClick();
			else
			{
				SourceTextBox.SaveSourceFile(this.currentFileName, RichTextBoxStreamType.PlainText);
				SourceTextBox.Modified = false;
				logger.LogWithTime("File saved: " + currentFileName);
			}
		}

		/**
		 * Open new blank file. (the same as close file till now)
		 **/
		private void menu_New_Click(object sender, System.EventArgs e)
		{
			CloseFile();
			logger.LogWithTime("New file opened...");
		}

		// ** Bye **
		private void menu_Exit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}


		/**
		 * Loads a source file into the textbox
		 **/
		private void menu_Open_Click(object sender, System.EventArgs e)
		{
			// ask user for saving old file
			if (isFileOpened)
			{
				if (CLOSE_RESULT.CANCEL == CloseFile())
					return;
			}

			// now open the new one
			OpenFileDialog ofd = new OpenFileDialog();
			ofd.Filter = FilterString;
			ofd.FilterIndex = 0;

			if (ofd.ShowDialog() == DialogResult.OK)
			{
				LoadFile(ofd.FileName);
				Reset();
			}
		}


		/**
		 * Toggle visibility of MemTable
		 **/
		private void Menu_View_MemTable_Click(object sender, System.EventArgs e)
		{
			Menu_View_MemTable.Checked = !Menu_View_MemTable.Checked;
			MemTable.Visible = !MemTable.Visible;
		}

		/**
		 * Toggle visibility of MemPanel
		 **/
		private void Menu_View_MemPanel_Click(object sender, System.EventArgs e)
		{
			Menu_View_MemPanel.Checked = !Menu_View_MemPanel.Checked;
			MemPanel.Visible = !MemPanel.Visible;
		}

		/**
		 * Show about dialog
		 **/
		private void menu_About_Click(object sender, System.EventArgs e)
		{
			// show About Box
			BrainfuckStudio.AboutBox box = new AboutBox();
			box.ShowDialog();
		}

		/**
		 * Toggle check brackets before executing menu item
		 **/
		private void menu_CheckBrackets_Click(object sender, System.EventArgs e)
		{
			this.menu_CheckBrackets.Checked = !this.menu_CheckBrackets.Checked;
		}

		/**
		 * Edit Sub Menu
		 **/

		private void menu_Cut_Click(object sender, System.EventArgs e)
		{
			SourceTextBox.Cut();
		}

		private void menu_Copy_Click(object sender, System.EventArgs e)
		{
			SourceTextBox.Copy();
		}

		private void menu_Paste_Click(object sender, System.EventArgs e)
		{
			SourceTextBox.Paste();
		}

		private void menu_SelectAll_Click(object sender, System.EventArgs e)
		{
			SourceTextBox.Focus();
			SourceTextBox.SelectAll();
		}


		// here we simulate clicks on the toolbar buttons 

		private void menu_Run_Click(object sender, System.EventArgs e)
		{
			this.toolBar1_ButtonClick(this, new System.Windows.Forms.ToolBarButtonClickEventArgs(this.ExecuteButton));
		}

		private void menu_Step_Click(object sender, System.EventArgs e)
		{
			this.toolBar1_ButtonClick(this, new System.Windows.Forms.ToolBarButtonClickEventArgs(this.StepButton));
		}

		private void menu_RunToCursor_Click(object sender, System.EventArgs e)
		{
			this.toolBar1_ButtonClick(this, new System.Windows.Forms.ToolBarButtonClickEventArgs(this.RunToCursorButton));
		}

		private void menu_PauseExec_Click(object sender, System.EventArgs e)
		{
			this.toolBar1_ButtonClick(this, new System.Windows.Forms.ToolBarButtonClickEventArgs(this.StopButton));
		}

		private void menu_Restart_Click(object sender, System.EventArgs e)
		{
			this.toolBar1_ButtonClick(this, new System.Windows.Forms.ToolBarButtonClickEventArgs(this.ResetButton));
		}

		private void menu_FileAssoc_Click(object sender, System.EventArgs e)
		{
			FileExtensionDlg dlg = new FileExtensionDlg();
			dlg.Show();
		}


		/**
		 * SubMenu -> Datatypes Handling
		 **/
		private void menu_Byte_Click(object sender, System.EventArgs e)
		{
			memBand.DataType = MemoryBand.DATATYPE.BYTE;
			this.menu_Byte.Checked = true;
			this.menu_SByte.Checked = false;
			this.menu_Short.Checked = false;
			this.menu_SShort.Checked = false;
			this.menu_Int.Checked = false;
			logger.LogWithTime("Cell datatype set to... BYTE.");
		}

		private void menu_SByte_Click(object sender, System.EventArgs e)
		{
			memBand.DataType = MemoryBand.DATATYPE.SIGNED_BYTE;
			this.menu_Byte.Checked = false;
			this.menu_SByte.Checked = true;
			this.menu_Short.Checked = false;
			this.menu_SShort.Checked = false;
			this.menu_Int.Checked = false;
			logger.LogWithTime("Cell datatype set to... SIGNED BYTE.");
		}

		private void menu_Short_Click(object sender, System.EventArgs e)
		{
			memBand.DataType = MemoryBand.DATATYPE.SHORT;
			this.menu_Byte.Checked = false;
			this.menu_SByte.Checked = false;
			this.menu_Short.Checked = true;
			this.menu_SShort.Checked = false;
			this.menu_Int.Checked = false;
			logger.LogWithTime("Cell datatype set to... SHORT.");
		}

		private void menu_SShort_Click(object sender, System.EventArgs e)
		{
			memBand.DataType = MemoryBand.DATATYPE.SIGNED_SHORT;
			this.menu_Byte.Checked = false;
			this.menu_SByte.Checked = false;
			this.menu_Short.Checked = false;
			this.menu_SShort.Checked = true;
			this.menu_Int.Checked = false;
			logger.LogWithTime("Cell datatype set to... SIGNED SHORT.");
		}

		private void menu_Int_Click(object sender, System.EventArgs e)
		{
			memBand.DataType = MemoryBand.DATATYPE.SIGNED_INT;
			this.menu_Byte.Checked = false;
			this.menu_SByte.Checked = false;
			this.menu_Short.Checked = false;
			this.menu_SShort.Checked = false;
			this.menu_Int.Checked = true;
			logger.LogWithTime("Cell datatype set to... SIGNED INTEGER.");
		}

		#endregion
	
		/**************************************************
		 *** PROPERTIES
		 **************************************************/
		#region Properties

		public bool isFileOpened
		{
			get { return !this.currentFileName.Equals(""); }
		}
		#endregion


	}
}
