using System;


// The logger class is in fact a listbox capsulated as a singleton.

namespace BrainfuckStudio
{
	/// <summary>
	/// Zusammenfassung fr Logger.
	/// </summary>
	public class Logger
	{
		private static Logger logger = null;
		private System.Windows.Forms.ListBox logbox = null;

		/**
		 * private constructor
		 **/
		private Logger()
		{
			// init the listbox
			this.logbox = new System.Windows.Forms.ListBox();
			this.logbox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.logbox.Location = new System.Drawing.Point(0, 0);
			this.logbox.Name = "LogList";
			this.logbox.Size = new System.Drawing.Size(363, 147);
			this.logbox.TabIndex = 0;
			// add contextmenu to logbox
			System.Windows.Forms.ContextMenu menu = new System.Windows.Forms.ContextMenu();
			menu.MenuItems.Add("Clear box");
			menu.MenuItems[0].Click += new EventHandler(Menu_Clear);
			this.logbox.ContextMenu = menu;
			
		}

		/**
		 * returns an instance to this
		 **/
		public static Logger getLogger()
		{
			if (logger == null)
			{
				logger = new Logger();	
			}
			return logger;
				
		}

		
		/**
		 * logs a message
		 **/
		public void Log(String s)
		{
			if (s != null)
				logbox.Items.Add(s);

			// just check if we should delete some old logs
			if (logbox.Items.Count > 50)
			{
				// delete first ten logs
				for (int i = 0; i < 10; i++)
					logbox.Items.RemoveAt(0);
			}

			// make sure we are at the bottom of the list
			this.logbox.SelectedIndex = this.logbox.Items.Count - 1;
			// here we scrolled to last element, so disselect it
			this.logbox.SelectedIndex = -1;
		}

		/**
		 * logs message with time
		 **/
		public void LogWithTime(String s)
		{
			if (s != null)
			{
				System.DateTime now = System.DateTime.Now;
				String tempstr = String.Format("{0:G} - ", now);
				Log(tempstr + s);
			}
		}

		/**
		 * log message with time and marked as an error
		 **/
		public void LogErrorWithTime(String s)
		{
			LogWithTime("ERROR: " + s);
		}


		// clear the log
		private void Menu_Clear(object sender, EventArgs e)
		{
			logbox.Items.Clear();
		}

		// get handle to listbox
		public System.Windows.Forms.ListBox getListBox()
		{
			return logbox;
		}
	}
}
